'#####################################################################
'# Funktion zum Aufruf der Verzeichnisstruktur                       #
'# Autor: Hans W. Herber - hans@herber.de - http://www.herber.de     #
'# Erstellt im Februar 2001                                          #
'# ----------------------------------------------------------------- #
'# Optionaler Parameter msg = anzuzeigende Dialogberschrift         #
'#####################################################################

Public Type BROWSEINFO
   hOwner As Long
   pidlRoot As Long
   pszDisplayName As String
   lpszTitle As String
   ulFlags As Long
   lpfn As Long
   lParam As Long
   iImage As Long
End Type

Declare Function SHGetPathFromIDList Lib "shell32.dll" _
   Alias "SHGetPathFromIDListA" (ByVal pidl As Long, _
   ByVal pszPath As String) As Long

Declare Function SHBrowseForFolder Lib "shell32.dll" _
   Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

Sub DirAuswahl()
   Dim msg As String
   msg = "Whlen Sie bitte einen Ordner aus:"
   MsgBox getdirectory(msg)
End Sub

Function getdirectory(Optional msg) As String
   Dim bInfo As BROWSEINFO
   Dim Path As String
   Dim r As Long, x As Long, pos As Integer
   bInfo.pidlRoot = 0&
   If IsMissing(msg) Then
      bInfo.lpszTitle = "Whlen Sie bitte einen Ordner aus."
   Else
      bInfo.lpszTitle = msg
   End If
   bInfo.ulFlags = &H1
   x = SHBrowseForFolder(bInfo)
   Path = Space$(512)
   r = SHGetPathFromIDList(ByVal x, ByVal Path)
   If r Then
      pos = InStr(Path, Chr$(0))
      getdirectory = Left(Path, pos - 1)
   Else
      getdirectory = ""
   End If
End Function
